# Generated by `rjournal_pdf_article()` using `knitr::purl()`: do not edit by hand
# Please edit genmarkov.Rmd to modify this file

## ----dim-pow-html, eval = knitr::is_html_output(), echo=FALSE-----------------
#> 
#> data = matrix(c('Power', '$H_0: \\lambda_{11} = 0$',
#>                 '$\\frac{\\widehat{\\lambda}_{11}^2}{se(\\widehat{\\lambda}_{11})^2} \\sim \\chi^2_{(1)}$',
#>                 '', '$H_0: \\lambda_{12} = 1$',
#>                 '$\\frac{(\\widehat{\\lambda}_{12}-1)^2}{se(\\widehat{\\lambda}_{12})^2} \\sim \\chi^2_{(1)}$',
#>                 'Dimension', '$H_0: \\lambda_{11} = 1$',
#>                 '$\\frac{(\\widehat{\\lambda}_{11}-1)^2}{se(\\widehat{\\lambda}_{11})^2} \\sim \\chi^2_{(1)}$',
#>                  '', '$H_0: \\lambda_{12} = 0$',
#>                 '$\\frac{\\widehat{\\lambda}_{12}^2}{se(\\widehat{\\lambda}_{12})^2} \\sim \\chi^2_{(1)}$'), ncol=3, nrow=4, byrow=T)
#> colnames(data) = c('', 'Hypothesis', 'Test')
#> 
#> knitr::kable(data, format = "html", caption = "Power and dimension of test assessment")


## ----dim-pow-tex, eval = knitr::is_latex_output(), echo=FALSE-----------------

data = matrix(c('Power', '$H_0: \\lambda_{11} = 0$',
                '$\\frac{\\widehat{\\lambda}_{11}^2}{se(\\widehat{\\lambda}_{11})^2} \\sim \\chi^2_{(1)}$',
                '', '$H_0: \\lambda_{12} = 1$', 
                '$\\frac{(\\widehat{\\lambda}_{12}-1)^2}{se(\\widehat{\\lambda}_{12})^2} \\sim \\chi^2_{(1)}$',
                'Dimension', '$H_0: \\lambda_{11} = 1$', 
                '$\\frac{(\\widehat{\\lambda}_{11}-1)^2}{se(\\widehat{\\lambda}_{11})^2} \\sim \\chi^2_{(1)}$',
                 '', '$H_0: \\lambda_{12} = 0$', 
                '$\\frac{\\widehat{\\lambda}_{12}^2}{se(\\widehat{\\lambda}_{12})^2} \\sim \\chi^2_{(1)}$'), ncol=3, nrow=4, byrow=T)
colnames(data) = c('', 'Hypothesis', 'Test')

knitr::kable(data, format = "latex", caption = "Power and dimension of test assessment", escape = FALSE)


## ----figure-2states, echo=FALSE, fig.cap="Simulation study results for two-states, displaying the proportion of rejections of the null hypothesis for two parameter values. Dimension of test remains stable regardless sample size. Power of test increases with sample size. The proposed model detects the presence of non-homogenenous Markov Chain.", warning=FALSE, message=FALSE, fig.height=3, fig.width=6, fig.align='center'----
library(ggplot2)
df <- structure(
  list(
    States = c(2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3,
               3, 3),
    Parameter = c(1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0),
    Sample = c(
      100,
      500,
      1000,
      5000,
      100,
      500,
      1000,
      5000,
      100,
      500,
      1000,
      100,
      500,
      1000
    ),
    Power = c(
      0.082,
      0.252,
      0.466,
      0.994,
      0.082,
      0.252,
      0.466,
      0.994,
      0.905,
      1,
      1,
      0.905,
      1,
      1
    ),
    Dimension = c(
      0.057,
      0.076,
      0.058,
      0.06,
      0.057,
      0.076,
      0.058,
      0.06,
      0.097,
      0.002,
      0.003,
      0.097,
      0.002,
      0.003
    )
  ),
  row.names = c(NA, 14L),
  class = "data.frame"
)

df$Sample = as.factor(df$Sample)
df$Parameter = as.factor(df$Parameter)

df1 <- df[df$States == 2, ]
p1 <-
  ggplot(df1,
         aes(
           x = Sample,
           y = Dimension,
           group = Parameter,
           fill = Parameter
         )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 0.08)) +
  geom_text(
    aes(label = Dimension * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
  labs(title='Dimension of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis', 
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

p2 <-
  ggplot(df1, aes(
    x = Sample,
    y = Power,
    group = Parameter,
    fill = Parameter
  )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 1.05)) +
  geom_text(
    aes(label = Power * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
  labs(title='Power of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

gridExtra::grid.arrange(p1, p2, ncol=2)



## ----figure-3states, echo=FALSE, fig.cap="Simulation study results for three-states, displaying the proportion of rejections of the null hypothesis for two parameter values. Dimension of test decreases as sample size increases. Power of test is stable regardless of sample size. The proposed model detects the presence of non-homogenenous Markov Chain.", warning=FALSE, message=FALSE, fig.height=3, fig.width=6, fig.align='center'----
df2 <- df[df$States == 3, ]
p3 <-
  ggplot(df2,
         aes(
           x = Sample,
           y = Dimension,
           group = Parameter,
           fill = Parameter
         )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 0.11)) +
  geom_text(
    aes(label = Dimension * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
  labs(title='Dimension of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

p4 <-
  ggplot(df2, aes(
    x = Sample,
    y = Power,
    group = Parameter,
    fill = Parameter
  )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 1.05)) +
  geom_text(
    aes(label = Power * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
  labs(title='Power of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

gridExtra::grid.arrange(p3, p4, ncol=2)


## ----figure-persistent-1, echo=FALSE, fig.cap="Simulation study results for persistent states on low values of the parameters (case 1), displaying the proportion of rejections of the null hypothesis for four parameter values. Dimension decreases as sample size increases. Power of test increases with sample size. The proposed model has low power of test when low parameter values are associated with persistent states.", warning=FALSE, message=FALSE, fig.height=3, fig.width=6, fig.align='center'----
df3 <-
  structure(
    list(
      Case = c(
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2
      ),
      Parameter = c(
        0.2,
        0.2,
        0.2,
        0.2,
        0.4,
        0.4,
        0.4,
        0.4,
        0.6,
        0.6,
        0.6,
        0.6,
        0.8,
        0.8,
        0.8,
        0.8,
        0.2,
        0.2,
        0.2,
        0.2,
        0.4,
        0.4,
        0.4,
        0.4,
        0.6,
        0.6,
        0.6,
        0.6,
        0.8,
        0.8,
        0.8,
        0.8
      ),
      Sample = c(
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000,
        100,
        500,
        1000,
        5000
      ),
      Power = c(
        0.073,
        0.065,
        0.046,
        0.019,
        0.092,
        0.096,
        0.092,
        0.097,
        0.126,
        0.282,
        0.261,
        0.276,
        0.139,
        0.435,
        0.695,
        0.999,
        0.057,
        0.076,
        0.15,
        0.256,
        0.085,
        0.14,
        0.209,
        0.715,
        0.071,
        0.087,
        0.142,
        0.315,
        0.053,
        0.103,
        0.362,
        0.599
      ),
      Dimension = c(
        0.018,
        0.014,
        0.009,
        0,
        0.005,
        0.004,
        0.002,
        0.002,
        0.005,
        0.004,
        0.002,
        0.002,
        0.018,
        0.014,
        0.009,
        0,
        0.018,
        0.025,
        0.038,
        0.064,
        0.002,
        0.003,
        0.07,
        0.103,
        0.002,
        0.003,
        0.07,
        0.103,
        0.018,
        0.025,
        0.038,
        0.064
      )
    ),
    row.names = c(NA,
                  32L),
    class = "data.frame"
  )
df3$Sample = as.factor(df3$Sample)
df3$Parameter = as.factor(df3$Parameter)

df4 <- df3[df3$Case == 1, ]

p5 <-
  ggplot(df4, aes(
    x = Sample,
    y = Power,
    group = Parameter,
    fill = Parameter
  )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 1.07)) +
  geom_text(
    aes(label = Power * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
    labs(title='Power of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

p6 <-
  ggplot(df4,
         aes(
           x = Sample,
           y = Dimension,
           group = Parameter,
           fill = Parameter
         )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 0.02)) +
  geom_text(
    aes(label = Dimension * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
    labs(title='Dimension of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )

gridExtra::grid.arrange(p6, p5, ncol=2)



## ----figure-persistent-2, echo=FALSE, fig.cap="Simulation study results for persistent states on high values of the parameters (case 2), displaying the proportion of rejections of the null hypothesis for four parameter values. Dimension and power of test increase as sample size increases. The results point towards a low test power in this setting.", fig.height=3, fig.width=6, warning=FALSE, fig.align='center'----
 df5 <- df3[df3$Case == 2, ]
p7 <-
  ggplot(df5, aes(
    x = Sample,
    y = Power,
    group = Parameter,
    fill = Parameter
  )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 0.8)) +
  geom_text(
    aes(label = Power * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
    labs(title='Power of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 7, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  )


p8 <-
  ggplot(df5,
         aes(
           x = Sample,
           y = Dimension,
           group = Parameter,
           fill = Parameter
         )) +
  geom_col(position = "dodge") +
  scale_y_continuous(labels = scales::percent, limits = c(0, 0.11)) +
  geom_text(
    aes(label = Dimension * 100),
    size = 2.5,
    hjust = -0.15,
    position =  position_dodge(.9),
    angle = 90
  ) +
  scale_fill_brewer(palette = 'Reds') +
  theme_minimal() +
    labs(title='Dimension of test',
       x='Sample size', 
       y = 'Proportion of rejections of the null hypothesis',
       fill = expression(lambda[jk])) +
  theme(
    axis.text.x = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.text.y = element_text(face = "bold", color = 'black',
                               size = 7),
    axis.title = element_text(size = 7),
    legend.title = element_text(size = 8, color = 'black'),
    legend.text = element_text(size = 7),
    title = element_text(size=7)
  ) 

gridExtra::grid.arrange(p8, p7, ncol=2)



## ----multi.mtd, eval=FALSE----------------------------------------------------
#> multi.mtd(y=cbind(s1,s2), deltaStop=0.0001, is_constrained=TRUE, delta=0.1)


## ----multi.mtd_probit, eval=FALSE---------------------------------------------
#> multi.mtd_probit(y = cbind(s1,s2), initial=c(1,1,1), nummethod='bfgs')


## ----mmcx-examp, eval=FALSE---------------------------------------------------
#> mmcx(y = cbind(s1,s2), x = cbind(x), initial=c(1,1))


## ----mmc_tpm, eval=FALSE------------------------------------------------------
#> MMC_tpm(s = cbind(s1,s2), x = cbind(x), value = max(x), result = res)


## ----summary-stat-html, eval = knitr::is_html_output(), echo=FALSE------------
#> library(GenMarkov)
#> data = rbind(c('$spread_{t}$', round(summary(stockreturns$spread_1), 3)),
#>              c('$r_{t;SP500}$', round(summary(stockreturns$returns_sp500), 3)),
#>              c('$r_{t;DJIA}$', round(summary(stockreturns$returns_djia), 3)))
#> 
#> colnames(data) = c('Variable', 'Minimum',
#>                    '1$^{st}$ Quantile', 'Median',
#>                    'Mean', '3$^{rd}$ Quantile', 'Maximum')
#> knitr::kable(data, format = "html", caption = "Summary statistics of $stockreturns$ dataset")


## ----summary-stat-tex, eval = knitr::is_latex_output(), echo=FALSE------------
library(GenMarkov)
data = rbind(c('$spread_{t}$', round(summary(stockreturns$spread_1), 3)),
             c('$r_{t;SP500}$', round(summary(stockreturns$returns_sp500), 3)),
             c('$r_{t;DJIA}$', round(summary(stockreturns$returns_djia), 3)))

colnames(data) = c('Variable', 'Minimum', 
                   '1$^{st}$ Quantile', 'Median', 
                   'Mean', '3$^{rd}$ Quantile', 'Maximum')

knitr::kable(data, format = "latex", caption = "Summary statistics of $stockreturns$ dataset", escape=FALSE)


## ----generate-plots, echo=FALSE, warning=FALSE, message=FALSE-----------------
library(GenMarkov)
library(ggplot2)
library(gridExtra)
#Define data and variables
s = cbind(stockreturns$sp500, stockreturns$djia)
m1 = max(s)
x = stockreturns$spread_1

###########################################################
### Code retrieved from ProbValuesXDependent() function ###
###########################################################

# Create matrix with dummies for each state
dummies_list <-
  apply(s, 2, function(x) {
    fastDummies::dummy_cols(x, remove_selected_columns = TRUE)
  })
dummies <- matrix(unlist(dummies_list),
                  ncol = m1 * ncol(s),
                  nrow = nrow(s)
)

# Create all possible combinations of column indices
combinations <- expand.grid(1:ncol(s), 1:ncol(dummies))
# Order by the first variable
combinations <- combinations[order(combinations$Var1), ]

# Extract columns from S and S_L based on the combinations
combined_list <- lapply(1:nrow(combinations), function(i, x) {
  cbind(s[, combinations[i, 1]], x, dummies[, combinations[i, 2]])
}, x = x)

estimate_condprobs <- sapply(combined_list, function(data) {
  # Define dependent variable
  y <- factor(data[, 1], levels = 1:max(data[, 1]))
  
  # Define lagged St
  s_l <- Hmisc::Lag(data[, 3])
  
  # Estimate multinomial logistic regression
  res <- suppressWarnings(nnet::multinom(y[s_l == 1] ~ data[, "x"][s_l == 1], trace = FALSE))
  
  warn <- tryCatch(
    {
      nnet::multinom(y[s_l == 1] ~ data[, "x"][s_l == 1], trace = FALSE)
      
      if (length(warnings()) == 0) {
        NULL  # Return NULL if no warning occurs
      }
      
    },
    warning = function(w) {
      # Extracting the warning message without printing
      warning_message <- conditionMessage(w)
      return(warning_message)
    }
  )
  
  
  if(is.null(warn)){
    # Extract fitted values
    px1 <- res$fitted.values
    
  }else if(length(warn) == 1){
    
    if( (grepl("\\bgroup\\b.*\\bempty\\b", warn, ignore.case = TRUE) || grepl("\\bgroups\\b.*\\bempty\\b", warn, ignore.case = TRUE)) ){
      extracted_number <- as.numeric(regmatches(warn, gregexpr("\\d+", warn))[[1]])
      
      # Extract fitted values
      px1 <- res$fitted.values
      
      ##Add missing groups
      px1 <- cbind(px1, matrix(rep(0, nrow(px1)*length(extracted_number)),
                               ncol=length(extracted_number),
                               nrow = nrow(px1),
                               dimnames = list(NULL, extracted_number)))
      
      #Re-order columns
      px1 <- px1[, match(1:m1, colnames(px1))]
    }else{
      warning(warn)
    }
    
  }else{
    warning(warn)
  }
  
  state = data[data[,3]==1,1][1]
  colnames(px1) = rep(paste('From state ', state), 3)
  
  return(as.matrix(px1))
}, simplify = "array")

#####
#Subset each conditional probabilities

##S1t, S1t-1
estim_prob_11 = estimate_condprobs[1:3]

##S1t, S2t-1
estim_prob_12 = estimate_condprobs[4:6]

##S2t, S1t-1
estim_prob_21 = estimate_condprobs[7:9]

##S2t, S2t-1
estim_prob_22 = estimate_condprobs[10:12]


#Function to create plots
plots_estimprobs = function(df){
  plots_list  <- list()
  j = colnames(df)[1]
 for(i in 1:3){
   ma = pracma::movavg(df[,i], n = 5, type = "s")
   df_ma = data.frame(ma = ma, Time = seq(1, nrow(df)))
   
   plot = ggplot(df_ma, aes(x = Time,
                         y = ma)) +
     geom_line(color = 'black') +
     ylab(label = paste(j, 'to state ', i)) +
     theme_minimal() +
     theme(axis.title = element_text(size = 8))
   
   plots_list[[i]] <- plot
 } 
  
  plots_res = arrangeGrob(grobs = plots_list, ncol = 3)
  
  return(plots_res)
}

#Save plots list
plots11 = lapply(estim_prob_11, function(x) plots_estimprobs(x))

plots12 = lapply(estim_prob_12, function(x) plots_estimprobs(x))

plots21 = lapply(estim_prob_21, function(x) plots_estimprobs(x))

plots22 = lapply(estim_prob_22, function(x) plots_estimprobs(x))



## ----fig11, echo=FALSE, fig.align='center', fig.cap="Estimated conditional probabilities of series 1 (SP500) depending on $spread_{t-1}$ and on series 1 (SP500) previous state: $P(S_{sp500,t} | S_{sp500, t-1}, spread_{t-1})$. This figure shows the estimated non-homogeneous Markov chain from which the realized probabilites will be extracted to maximize the log-likelihood function.", message=FALSE, warning=FALSE, out.width='70%'----
grid.arrange(grobs = plots11, nrow=3)


## ----fig12, echo=FALSE, fig.align='center', fig.cap="Estimated conditional probabilities of series 1 (SP500) depending on $spread_{t-1}$ and on series 2 (DJIA) previous state: $P(S_{sp500,t} | S_{djia, t-1}, spread_{t-1})$. This figure shows the estimated non-homogeneous Markov chain from which the realized probabilites will be extracted to maximize the log-likelihood function.", , out.width='70%'----
grid.arrange(grobs = plots12, nrow=3)


## ----fig21, echo=FALSE, fig.align='center', fig.cap="Estimated conditional probabilities of series 2 (DJIA) depending on $spread_{t-1}$ and on series 1 (SP500) previous state: $P(S_{djia,t} | S_{sp500, t-1}, spread_{t-1})$. This figure shows the estimated non-homogeneous Markov chain from which the realized probabilites will be extracted to maximize the log-likelihood function.", , out.width='70%'----
grid.arrange(grobs = plots21, nrow=3)


## ----fig22, echo=FALSE, fig.align='center', fig.cap="Estimated conditional probabilities of series 2 (DJIA) depending on $spread_{t-1}$ and on series 2 (DJIA) previous state: $P(S_{djia,t} | S_{djia, t-1}, spread_{t-1})$. This figure shows the estimated non-homogeneous Markov chain from which the realized probabilites will be extracted to maximize the log-likelihood function.", , out.width='70%'----
grid.arrange(grobs = plots22, nrow=3)


## ----mmcx---------------------------------------------------------------------
attach(stockreturns)
res <- mmcx(cbind(sp500, djia), spread_1, initial=c(1,1))


## ----tpm----------------------------------------------------------------------
tpm_max <- MMC_tpm(cbind(sp500, djia), spread_1, 
                   value = max(spread_1), result = res)

tpm_min <- MMC_tpm(cbind(sp500, djia), spread_1, 
                   value = min(spread_1), result = res)

## ----tpm-figs, eval=FALSE-----------------------------------------------------
#> library(markovchain)
#> plot(new('markovchain', transitionMatrix = tpm_max[,,1])) # Generate figure 9
#> plot(new('markovchain', transitionMatrix = tpm_min[,,1])) # Generate figure 10
#> plot(new('markovchain', transitionMatrix = tpm_max[,,2])) # Generate figure 11
#> plot(new('markovchain', transitionMatrix = tpm_min[,,2])) # Generate figure 12


## ----fig-sp500-max, fig.align='center', fig.cap="Graphical representation of the transition probability matrix of Series 1: SP500 for the maximum value of spread$_{t-1}$. The highest probability of 0.6 refers to the transition from state 2 to state 3.", out.width='60%', warning=FALSE, message=FALSE, echo=FALSE----
library(markovchain)
set.seed(123)
plot(new('markovchain', transitionMatrix = tpm_max[,,1]))


## ----fig-sp500-min, fig.align='center', fig.cap="Graphical representation of the transition probability matrix of Series 1: SP500 for the minimum value of spread$_{t-1}$. The highest probability of 0.56 refers to the transition from state 2 to state 2.", out.width='60%', echo=FALSE----
set.seed(123)
plot(new('markovchain', transitionMatrix = tpm_min[,,1]))


## ----fig-djia-max, fig.align='center', fig.cap="Graphical representation of the transition probability matrix of Series 2: DJIA for the maximum value of spread$_{t-1}$. The probability of 0.58 refers to the transition from state 2 to state 3.", out.width='60%', echo=FALSE----
set.seed(123)
plot(new('markovchain', transitionMatrix = tpm_max[,,2]))


## ----fig-djia-min, fig.align='center', fig.cap="Graphical representation of the transition probability matrix of Series 2: DJIA for the minimum value of spread$_{t-1}$. The highest probability of 0.51 refers to the transition from state 2 to state 2.",out.width='60%', echo=FALSE----
set.seed(123)
plot(new('markovchain', transitionMatrix = tpm_min[,,2]))

